***
* dbRoll Sistemas e Adm de Dados 
* by Mazzarino, 2003
* BOClass Signin
***
DEFINE CLASS signin AS Session OLEPUBLIC

Names = ""
Passwords = ""
Emails = ""
Uens = ""
Roles = ""
oNet = null

PROCEDURE Init(ConnectionString as String) as Boolean
LOCAL llStatus as Boolean
	
*--this hardcode is optional
IF PCOUNT()=0 OR TYPE("ConnectionString")#"C"
	ConnectionString = ;
	"server=localhost;Trusted_Connection=false;database=portal;uid=sa;pwd=;"
ENDIF
*--
llStatus = this.ConnectToDotNet(ConnectionString)
RETURN llStatus
ENDPROC

PROCEDURE ConnectToDotNet(ConnectionString as String) as Boolean
LOCAL llStatus as Boolean

IF TYPE("this.oNet")#"O"
	this.oNet=CREATEOBJECT("dbrollsistemas.dataservices.vfpnet")
ENDIF
IF TYPE("this.oNet")#"O"
	RETURN llStatus
ENDIF
llStatus = .T.
IF TYPE("ConnectionString")="C" AND !EMPTY(ConnectionString)
	this.oNet.SetConnection(ConnectionString)
ENDIF
RETURN llStatus	
ENDPROC

PROCEDURE GetUsers(Uen as String) as String

this.oNet.MakeParm("@UenName",Uen,.F.)
this.oNet.MakeParm("@PortalId",1,.F.)
LOCAL oReader as Object
oReader = this.oNet.RunSqlProcedure("GetAuthNames",null)
IF ISNULL(oReader)
	RETURN NULL
ELSE
	STORE SPACE(0) TO this.Names,this.Passwords,this.EMails	
	DO WHILE oReader.Read()
		this.Names = this.StrAdd(this.Names,oReader.GetString(0))
		this.Passwords = this.StrAdd(this.Passwords,oReader.GetString(1))
		this.Emails = this.StrAdd(this.Emails,oReader.GetString(2))
	ENDDO
	oReader.Close()
ENDIF
RETURN this.Names
ENDPROC


PROCEDURE signin(Name as String,Password as String) as String

this.oNet.MakeParm("@UserName",Name,.F.)
this.oNet.MakeParm("@Password",Password,.F.)
this.oNet.MakeParm("@PortalId",1,.F.)
LOCAL oReader as Object
oReader = this.oNet.RunSqlProcedure("GetAuthUens",null)
this.Uens = ""
DO WHILE oReader.Read()
	this.uens = this.strAdd(this.Uens,oReader.GetString(0))
ENDDO	
oReader.Close()
RETURN this.Uens
ENDPROC

PROCEDURE GetRoles(Name as String,Password as string) as String

this.oNet.MakeParm("@UserName",Name,.F.)
this.oNet.MakeParm("@Password",Password,.F.)
this.oNet.MakeParm("@PortalId",1,.F.)
LOCAL oReader as Object
oReader = this.oNet.RunSqlProcedure("GetUserRoles",null)
IF ISNULL(oReader)
	RETURN NULL
ELSE
	this.Roles = ""
	DO WHILE oReader.Read()
		this.Roles = this.strAdd(this.Roles,oReader.GetString(0))
	ENDDO
	oReader.Close()
ENDIF
RETURN this.Roles
ENDPROC

PROCEDURE GetTabs(MapaId as String) as String
LOCAL Roles as String
IF TYPE("MapaId")="N"
	MapaId = ALLTRIM(STR(MapaId))
ENDIF
this.oNet.MakeParm("@TabName",SPACE(55),.T.)
this.oNet.MakeParm("@AuthorizedRoles",SPACE(255),.T.)
this.oNet.MakeParm("@MapId",MapaId,.F.)
this.oNet.MakeParm("@PortalId",1,.F.)
oCol = this.oNet.RunSqlProcedure("GetMapDescription",NULL)
this.oNet.CloseConnection()
IF this.oNet.HasError
	? this.oNet.ErrorMessage
ELSE
	Roles = oCol.Item(1).Value
	oCol.Clear()
ENDIF
RETURN Roles
ENDPROC

PROCEDURE IsInRoles(MapId as String,UserContext as String) as Boolean
LOCAL Roles as String,xRole as String,Idx as Number

IF TYPE("MapId")="N"
	MapId = ALLTRIM(STR(MapId))
ENDIF
Roles = this.GetTabs(MapId)
FOR Idx = 1 TO this.StrCount(Roles)-1
	xRole = this.StrOccur(Roles,Idx)
	IF !EMPTY(xRole) AND !ISNULL(xRole) ;
		AND (LOWER(xRole) == "all users" OR this.IsInRole(xRole,UserContext))
		RETURN .T.
	ENDIF
ENDFOR
RETURN .F.
ENDPROC

PROCEDURE IsInRole(Role as String,UserContext as String) as Boolean
	RETURN (this.StrWhere(UserContext,Role) > 0)
ENDPROC

PROCEDURE GetMessage() as String
	RETURN this.oNet.ErrorMessage
ENDPROC

***
*-- Mtodos de Apoio
***
HIDDEN FUNCTION StrAdd(cStringList,cString) as String
If PCOUNT()<=1
	Return cStringList
Endif
If Type('cString') != "C"
	Return cStringList
Endif
If Empty(cStringList) OR ISNULL(cStringList)
	cStringList = cString
Else
	cStringList = cStringList+','+cString
Endif
Return cStringList
ENDFUNC

HIDDEN Function StrOccur(cStringList,nIndex) as String
	Local lnStart,lnEnd,lnIdx

	If PCOUNT()<1
		Return ''
	Endif
	If Empty(cStringList) OR ISNULL(cStringList)
		Return ''
	Endif
	If PCOUNT() = 1
		Return Substr(cStringList,1,At(',',cStringList)-1)
	Endif
	If nIndex = 0
		Return ''
	Endif
	Store 0 To lnStart,lnEnd
	If nIndex > this.StrCount(cStringList)
		Return ''
	Endif
	If nIndex > 1
		lnStart = At(',',cStringList,nIndex-1)
		IF lnStart = 0
			lnStart = At(';',cStringList,nIndex-1)
		ENDIF
	Endif
	If nIndex > 0
		lnEnd= At (',',cStringList,nIndex)
		IF lnEnd = 0
			lnEnd = At(';',cStringList,nIndex)
		ENDIF
	Endif
	If lnEnd = 0
		Return Substr(cStringList,lnStart+1,Len(cStringList))
	Endif'
	Return Substr(cStringList,lnStart+1,lnEnd-lnStart-1)
Endfunc

HIDDEN Function StrCount(cStringList) as Number

	If PCOUNT() < 1
		Return 0
	Endif
	If Empty(cStringList) OR ISNULL(cStringList)
		Return 0
	Endif
	Local lnCount,lnOffSet
	Store 1 To lnCount,lnOffSet
	Do While lnOffSet != 0
		lnOffSet=At(',',cStringList,lnCount)
		If lnOffSet = 0
			lnOffSet = At(';',cStringList,lnCount)
			If lnOffSet = 0
				Return lnCount
			ENDIF
		endif
		lnCount=lnCount+1
	ENDDO
	RETURN lnCount
Endfunc

HIDDEN Function StrWhere (cStringList,cString) as Number
	Local lnStart,lnEnd,lnIdx

	If PCOUNT()<1
		Return 0
	Endif
	If Empty(cStringList) OR ISNULL(cStringList)
		Return 0
	Endif
	If PCOUNT() = 1
		Return 1
	Endif
	Store 0 To lnStart,lnEnd
	For lnIdx=1 To this.StrCount(cStringList)
		If LOWER(cString) == LOWER(this.stroccur(cStringList,lnIdx))
			Return lnIdx
		Endif
	Endfor
	Return 0
Endfunc

ENDDEFINE
*--EOClass Signin
***