#include WinEvents.H

lcCaption      = 'Command'
loEventHandler = createobject('IDEWindowsEvents')
lnhWnd         = loEventHandler.FindIDEWindow(lcCaption)
* Uncomment this code to receive events for the window's client window instead
*lnhWnd         = loEventHandler.FindIDEClientWindow(lcCaption)
if lnhWnd > 0
	bindevent(lnhWnd, WM_SETFOCUS,      loEventHandler, 'EventHandler')
	bindevent(lnhWnd, WM_KILLFOCUS,     loEventHandler, 'EventHandler')
	bindevent(lnhWnd, WM_MOVE,          loEventHandler, 'EventHandler')
	bindevent(lnhWnd, WM_SIZE,          loEventHandler, 'EventHandler')
	bindevent(lnhWnd, WM_MOUSEACTIVATE, loEventHandler, 'EventHandler')
	bindevent(lnhWnd, WM_KEYDOWN,       loEventHandler, 'EventHandler')
	bindevent(lnhWnd, WM_KEYUP,         loEventHandler, 'EventHandler')
	bindevent(lnhWnd, WM_CHAR,          loEventHandler, 'EventHandler')
	bindevent(lnhWnd, WM_DEADCHAR,      loEventHandler, 'EventHandler')
	bindevent(lnhWnd, WM_KEYLAST,       loEventHandler, 'EventHandler')
	clear
	suspend
	clear
else
	messagebox('The ' + lcCaption + ' window was not found.')
endif lnhWnd > 0

define class IDEWindowsEvents as Custom
	cCaption = ''
	nOldProc = 0

	function Init
		declare integer GetWindowLong in Win32API ;
			integer hWnd, integer nIndex
		declare integer CallWindowProc in Win32API ;
			integer lpPrevWndFunc, integer hWnd, integer Msg, integer wParam, ;
			integer lParam
		declare integer FindWindowEx in Win32API;
			integer, integer, string, string
		declare integer GetWindowText in Win32API ;
			integer, string @, integer
		This.nOldProc = GetWindowLong(_screen.hWnd, GWL_WNDPROC)
	endfunc

	function FindIDEWindow(tcCaption)
		local lnhWnd, ;
			lnhChild, ;
			lcCaption
		This.cCaption = tcCaption
		lnhWnd        = _screen.hWnd
		lnhChild      = 0
		do while .T.
			lnhChild = FindWindowEx(lnhWnd, lnhChild, 0, 0)
			if lnhChild = 0
				exit
			endif lnhChild = 0
			lcCaption = space(80)
			GetWindowText(lnhChild, @lcCaption, len(lcCaption))
			lcCaption = upper(left(lcCaption, at(chr(0), lcCaption) - 1))
			if lcCaption = upper(tcCaption)
				exit
			endif lcCaption = upper(tcCaption)
		enddo while .T.
		return lnhChild
	endfunc

	function FindIDEClientWindow(tcCaption)
		local lnhWnd, ;
			lnwHandle, ;
			lnwChild
		lnhWnd = This.FindIDEWindow(tcCaption)
		if lnhWnd > 0
			lnwHandle = sys(2326, lnhWnd)
			lnwChild  = sys(2325, lnwHandle)
			lnhWnd    = sys(2327, lnwChild)
		endif lnhWnd > 0
		return lnhWnd
	endfunc

	function EventHandler(hWnd, Msg, wParam, lParam)
		? 'The ' + This.cCaption + ' window received event #' + transform(Msg)
		return CallWindowProc(This.nOldProc, hWnd, Msg, wParam, lParam)
	endfunc
enddefine

















